<?php
session_start();

header("Access-Control-Allow-Origin: *");

require_once("./conexao.php");

$conn = conn();
$conn_s = conn_s();

use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\SMTP;
use PHPMailer\PHPMailer\Exception;

require_once("../utils/phpmailer/Exception.php");
require_once("../utils/phpmailer/PHPMailer.php");
require_once("../utils/phpmailer/SMTP.php");

$loja_id = $_SESSION['loja'];

if (!empty($_POST['cod'])) {
  //Processo de cancelamento da solicitação
  if ($_POST['cod'] == 1) {
    if (!empty($_POST['senha']) && !empty($_POST['id_solicitacao'])) {
      //primeiro devo pegar os dados da pessoa que essa senha pertence
      $SQL   = "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'";
      $query = mysqli_query($conn, $SQL);
      $getDadosuser = mysqli_fetch_array($query);
      if (!empty($getDadosuser)) {
        if ($getDadosuser['senha_block'] == 1) {
          $alterarStatus = mysqli_query($conn, "UPDATE processos_iniciados SET situacao = '1' WHERE id = '".trim($_POST['id_solicitacao'])."'");
          if ($alterarStatus) {
            $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) 
            VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','10')");
            $var = array(
              'status'  => true,
              'msg'     => 'Cancelamento feito com sucesso!'
            );
          } else {
            $var = array(
              'status'  => false,
              'msg'     => 'Não foi possível cancelar a solicitação, tente novamente.'
            );
          }
        } else {
          $var = array(
            'status'  => false,
            'msg'     => 'Senha bloqueada.'
          );
        }  
      } else {
        $var = array(
          'status'  => false,
          'msg'     => 'Usuário não encontrado.'
        );
      }
    } else {
      if(empty($_POST['senha'])){
        $var = array(
          'status'  => false,
          'msg'     => 'Faltou a senha.'
        );
      } else if (empty($_POST['id_solicitacao'])){
        $var = array(
          'status' => false,
          'msg' => 'Faltou o identificador.'
        );
      } else {
        $var = array(
          'status' => false,
          'msg' => 'Todos os campos são obrigatórios.'
        );
      }
    }
  }
  //Retirar peça do depósito
  if ($_POST['cod'] == 2) {
    if (!empty($_POST['senha']) && !empty($_POST['id_solicitacao'])) {
      //primeiro devo pegar os dados da pessoa que essa senha pertence
      $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));
      if (!empty($getDadosuser)) {
        if ($getDadosuser['senha_block'] == 1) {
          $getLastAtividade = mysqli_fetch_array(mysqli_query($conn, "SELECT id_processo FROM processos_gerenciamento 
            WHERE id_processo_iniciado = '". $_POST['id_solicitacao'] ."' ORDER BY id DESC"));
          $insertAtividade = mysqli_query($conn, "INSERT INTO processos_atividade(processo_id,user_id,momento) 
            VALUES('". $_POST['id_solicitacao'] ."','". $getDadosuser['id'] ."','". $getLastAtividade['id_processo'] ."')");


          $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) 
            VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','2')");
          
          if ($addLine) {
            $var = array(
              'status'  => true,
              'msg'     => 'Processo concluído com sucesso!'
            );
          } else {
            $var = array(
              'status'  => false,
              'msg'     => 'Não foi possível concluir o processo, tente novamente.'
            );
          }
        } else {
          $var = array(
            'status'  => false,
            'msg'     => 'Senha bloqueada.'
          );
        }
      } else {
        $var = array(
          'status'  => false,
          'msg'     => 'Usuário não encontrado.'
        );
      }
    } else {
      $var = array(
        'status'  => false,
        'msg'     => 'Todos os campos são obrigatórios.'
      );
    }
  }
  //Peça recebida na boqueta
  if ($_POST['cod'] == 3) {
    $processo = true;
    if($_POST['loja_id'] != 1){
      /* EXECUTA COD 2 */ 
      if (!empty($_POST['senha']) && !empty($_POST['id_solicitacao'])) {
        //primeiro devo pegar os dados da pessoa que essa senha pertence
        $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));

        if (!empty($getDadosuser)) {
          if ($getDadosuser['senha_block'] == 1) {
            $getLastAtividade = mysqli_fetch_array(mysqli_query($conn, "SELECT id_processo FROM processos_gerenciamento 
              WHERE id_processo_iniciado = '". $_POST['id_solicitacao'] ."' ORDER BY id DESC"));
            $insertAtividade = mysqli_query($conn, "INSERT INTO processos_atividade(processo_id,user_id,momento) 
              VALUES('". $_POST['id_solicitacao'] ."','". $getDadosuser['id'] ."','". $getLastAtividade['id_processo'] ."')");


            $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) 
              VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','2')");
            
            if (!$addLine) {
              $processo = false;
            }
          } else {
            $processo = false;
          } 
        }
      } else { $processo = false; }
    }

    if (!empty($_POST['senha']) && !empty($_POST['id_solicitacao']) && $processo) {
      //primeiro devo pegar os dados da pessoa que essa senha pertence
      $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));
      if (!empty($getDadosuser)) {
        if ($getDadosuser['senha_block'] == 1) {
          $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) 
            VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','3')");

          //limpar as atividades
          $limparAtividades = mysqli_query($conn, "UPDATE processos_atividade SET status = '1' WHERE processo_id = '". trim($_POST['id_solicitacao']) ."'");
          if ($addLine) {
            $var = array(
              'status'  => true,
              'msg'     => 'Processo concluído com sucesso!'
            );
          } else {
            $var = array(
              'status'  => false,
              'msg'     => 'Não foi possível concluir o processo, tente novamente.'
            );
          }
        } else {
          $var = array(
            'status'  => false,
            'msg'     => 'Senha bloqueada.'
          );
        }
      } else {
        $var = array(
          'status'  => false,
          'msg'     => 'Usuário não encontrado.'
        );
      }
    } else if(!$processo){
      $var = array(
        'status'  => false,
        'msg'     => 'Não foi possível o identificar nos processos internos.'
      );
    } else {
      $var = array(
        'status'  => false,
        'msg'     => 'Todos os campos são obrigatórios.'
      );
    }
  }
  //Vendedor retira peça da boqueta
  if ($_POST['cod'] == 4) {
    if (!empty($_POST['senha']) && !empty($_POST['id_solicitacao'])) {
      //primeiro devo pegar os dados da pessoa que essa senha pertence
      $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));
      if (!empty($getDadosuser)) {
        if ($getDadosuser['senha_block'] == 1) {

          $getInstancia = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM processos_gerenciamento 
            WHERE id_processo_iniciado = '". trim($_POST['id_solicitacao']) ."' AND id_processo = '1'"));
          if ($getInstancia['id_user'] == $getDadosuser['id']) {
            $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) 
              VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','4')");
            if ($addLine) {
              $var = array(
                'status'  => true,
                'msg'     => 'Processo concluído com sucesso!'
              );
            } else {
              $var = array(
                'status'  => false,
                'msg'     => 'Não foi possível concluir o processo, tente novamente.'
              );
            }
          } else {
            $var = array(
              'status'  => false,
              'msg'     => 'Vendedor Incorreto.'
            );
          }
        } else {
          $var = array(
            'status'  => false,
            'msg'     => 'Senha bloqueada.'
          );
        }  
      } else {
        $var = array(
          'status'  => false,
          'msg'     => 'Usuário não encontrado.'
        );
      }
    } else {
      $var = array(
        'status'  => false,
        'msg'     => 'Todos os campos são obrigatórios.'
      );
    }
  }
  //Peça retornada para a boqueta p/despache
  if ($_POST['cod'] == 5) {
    if (!empty($_POST['senha']) && !empty($_POST['id_solicitacao'])) {
      //primeiro devo pegar os dados da pessoa que essa senha pertence
      $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));
      if (!empty($getDadosuser)) {
        if ($getDadosuser['senha_block'] == 1) {
          $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) 
            VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','5')");
          if ($addLine) {
            $var = array(
              'status'  => true,
              'msg'     => 'Processo concluído com sucesso!'
            );
          } else {
            $var = array(
              'status'  => false,
              'msg'     => 'Não foi possível concluir o processo, tente novamente.'
            );
          }
        } else {
          $var = array(
            'status'  => false,
            'msg'     => 'Senha bloqueada.'
          );
        }  
      } else {
        $var = array(
          'status'  => false,
          'msg'     => 'Usuário não encontrado.'
        );
      }
    } else {
      $var = array(
        'status'  => false,
        'msg'     => 'Todos os campos são obrigatórios.'
      );
    }
  }
  //Peça retornada para a boqueta p/guardar
  if ($_POST['cod'] == 6) {
    if (!empty($_POST['senha']) && !empty($_POST['id_solicitacao'])) {
      //primeiro devo pegar os dados da pessoa que essa senha pertence
      $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));
      if (!empty($getDadosuser)) {
        if ($getDadosuser['senha_block'] == 1) {
          $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) 
            VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','6')");
          if ($addLine) {
            $var = array(
              'status'  => true,
              'msg'     => 'Processo concluído com sucesso!'
            );
          } else {
            $var = array(
              'status'  => false,
              'msg'     => 'Não foi possível concluir o processo, tente novamente.'
            );
          }
        } else {
          $var = array(
            'status'  => false,
            'msg'     => 'Senha bloqueada.'
          );
        }
      } else {
        $var = array(
          'status'  => false,
          'msg'     => 'Usuário não encontrado.'
        );
      }
    } else {
      $var = array(
        'status'  => false,
        'msg'     => 'Todos os campos são obrigatórios.'
      );
    }
  }
  //Peça despachada
  if ($_POST['cod'] == 7) {
    if (!empty($_POST['senha']) && !empty($_POST['id_solicitacao'])) {
      //primeiro devo pegar os dados da pessoa que essa senha pertence
      $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));
      if (!empty($getDadosuser)) {
        if ($getDadosuser['senha_block'] == 1) {
          $alterarStatus = mysqli_query($conn, "UPDATE processos_iniciados SET situacao = '1' WHERE id = '".trim($_POST['id_solicitacao'])."'");
          if ($alterarStatus) {
            $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) 
            VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','7')");
            $var = array(
              'status'  => true,
              'msg'     => 'Processo concluído com sucesso!'
            );
          } else {
            $var = array(
              'status'  => false,
              'msg'     => 'Não foi possível concluir o processo, tente novamente.'
            );
          }
        } else {
          $var = array(
            'status'  => false,
            'msg'     => 'Senha bloqueada.'
          );
        }  
      } else {
        $var = array(
          'status'  => false,
          'msg'     => 'Usuário não encontrado.'
        );
      }
    } else {
      $var = array(
        'status'  => false,
        'msg'     => 'Todos os campos são obrigatórios.'
      );
    }
  }
  //Retirar Peça da boqueta para levar ao depósito
  if ($_POST['cod'] == 8) {
    if (!empty($_POST['senha']) && !empty($_POST['id_solicitacao'])) {
      //primeiro devo pegar os dados da pessoa que essa senha pertence
      $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));
      if (!empty($getDadosuser)) {
        if ($getDadosuser['senha_block'] == 1) {
          $getLastAtividade = mysqli_fetch_array(mysqli_query($conn, "SELECT id_processo FROM processos_gerenciamento 
            WHERE id_processo_iniciado = '". $_POST['id_solicitacao'] ."' ORDER BY id DESC"));
          $insertAtividade = mysqli_query($conn, "INSERT INTO processos_atividade(processo_id,user_id,momento) 
            VALUES('". $_POST['id_solicitacao'] ."','". $getDadosuser['id'] ."','". $getLastAtividade['id_processo'] ."')");

          $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) 
            VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','8')");
          
          if ($addLine) {
            $var = array(
              'status'  => true,
              'msg'     => 'Processo concluído com sucesso!'
            );
          } else {
            $var = array(
              'status'  => false,
              'msg'     => 'Não foi possível concluir o processo, tente novamente.'
            );
          }
        } else {
          $var = array(
            'status'  => false,
            'msg'     => 'Senha bloqueada.'
          );
        }
      } else {
        $var = array(
          'status'  => false,
          'msg'     => 'Usuário não encontrado.'
        );
      }
    } else {
      $var = array(
        'status'  => false,
        'msg'     => 'Todos os campos são obrigatórios.'
      );
    }
  }
  //Peça retornada ao depósito
  if ($_POST['cod'] == 9) {
    $processo = true;
    if($_POST['loja_id'] != 1){
      /* EXECUTA O COD 6 */ 
      if (!empty($_POST['senha']) && !empty($_POST['id_solicitacao'])) {
        //primeiro devo pegar os dados da pessoa que essa senha pertence
        $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));
        if (!empty($getDadosuser)) {
          if ($getDadosuser['senha_block'] == 1) {
            $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) 
              VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','6')");
            
            if (!$addLine) {
              $processo = false;
            }
          } else {
            $processo = false;
          }
        } else {
          $processo = false;
        }
      } else {
        $processo = false;
      }

      /* EXECUTA O COD 8 */ 
      if($processo){
        //primeiro devo pegar os dados da pessoa que essa senha pertence
        $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));
        if (!empty($getDadosuser)) {
          if ($getDadosuser['senha_block'] == 1) {
            $getLastAtividade = mysqli_fetch_array(mysqli_query($conn, "SELECT id_processo FROM processos_gerenciamento 
              WHERE id_processo_iniciado = '". $_POST['id_solicitacao'] ."' ORDER BY id DESC"));
            $insertAtividade = mysqli_query($conn, "INSERT INTO processos_atividade(processo_id,user_id,momento) 
              VALUES('". $_POST['id_solicitacao'] ."','". $getDadosuser['id'] ."','". $getLastAtividade['id_processo'] ."')");
  
            $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) 
              VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','8')");
            
            if (!$addLine) {
              $processo = false;
            }
          } else {
            $processo = false;
          }
        } else {
          $processo = false;
        }
      }
    }


    if (!empty($_POST['senha']) && !empty($_POST['id_solicitacao']) && $processo) {
      //primeiro devo pegar os dados da pessoa que essa senha pertence
      $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));
      if (!empty($getDadosuser)) {
        if ($getDadosuser['senha_block'] == 1) {
          $alterarStatus = mysqli_query($conn, "UPDATE processos_iniciados SET situacao = '1' WHERE id = '".trim($_POST['id_solicitacao'])."'");
          if ($alterarStatus) {
            $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) 
            VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','9')");
            //limpar as atividades
            $limparAtividades = mysqli_query($conn, "UPDATE processos_atividade SET status = '1' WHERE processo_id = '". trim($_POST['id_solicitacao']) ."'");
            $var = array(
              'status'  => true,
              'msg'     => 'Processo concluído com sucesso!'
            );
          } else {
            $var = array(
              'status'  => false,
              'msg'     => 'Não foi possível concluir o processo, tente novamente.'
            );
          }
        } else {
          $var = array(
            'status'  => false,
            'msg'     => 'Senha bloqueada.'
          );
        } 
      } else {
        $var = array(
          'status'  => false,
          'msg'     => 'Usuário não encontrado.'
        );
      }
    } else if(!$processo){
      $var = array(
        'status'  => false,
        'msg'     => 'Não foi possível o identificar nos processos internos.'
      );
    } else {
      $var = array(
        'status'  => false,
        'msg'     => 'Todos os campos são obrigatórios.'
      );
    }
  }

  if ($_POST['cod'] == 10) {

    if (!empty($_POST['id'])) {

      if (empty($_POST['status'])) {

        $novo_status = 1;

      } else {

        $novo_status = 0;

      }

      $updateStatus = mysqli_query($conn, "UPDATE user SET status = '$novo_status' WHERE id = '".$_POST['id']."'");

      if ($updateStatus) {

        $var = array(

          'status'  => true,

          'msg'     => 'Sucesso!'

        );

      } else {

        $var = array(

          'status'  => false,

          'msg'     => 'Falha, tente novamente.'

        );

      }

    } else {

      $var = array(

        'status'  => false,

        'msg'     => 'Todos os campos são obrigatórios.'

      );

    }

  }

  if ($_POST['cod'] == 11) {

    if (!empty($_POST['id'])) {

      $updateStatus = mysqli_query($conn, "DELETE FROM user WHERE id = '".$_POST['id']."'");

      if ($updateStatus) {

        $var = array(

          'status'  => true,

          'msg'     => 'Sucesso!'

        );

      } else {

        $var = array(

          'status'  => false,

          'msg'     => 'Falha, algunas informações do usuário estão sendo utilizadas nos processos.'

        );

      }

    } else {

      $var = array(

        'status'  => false,

        'msg'     => 'Todos os campos são obrigatórios.'

      );

    }

  }

  if ($_POST['cod'] == 12) {

    if (!empty($_POST['nome']) && !empty($_POST['email']) && !empty($_POST['senha']) && !empty($_POST['tipo'])) {

      $insertAccount_sql = "INSERT INTO user(nome,email,senha,tipo_user";
      if(!empty($_POST['senha_block'])){
        $insertAccount_sql .= ", senha_block"; 
      }
      if(!empty($_POST['loja'])){
        $insertAccount_sql .= ", loja_id"; 
      }
      if(!empty($_POST['user_geral'])){
        $insertAccount_sql .= ", user_geral"; 
      }

      $insertAccount_sql .= ") VALUES('".$_POST['nome']."','".$_POST['email']."','".md5($_POST['senha'])."','".$_POST['tipo']."'"; 
      if(!empty($_POST['senha_block'])){
        $insertAccount_sql .= ",'".$_POST['senha_block']."'"; 
      }
      if(!empty($_POST['loja'])){
        $insertAccount_sql .= ",".$_POST['loja']; 
      }
      if(!empty($_POST['user_geral'])){
        $insertAccount_sql .= ", '".$_POST['user_geral']."'"; 
      }
      
      $insertAccount_sql .= ")";
      $insertAccount     = mysqli_query($conn, $insertAccount_sql);

      if ($insertAccount) {

        $var = array(

          'status'  => true,

          'msg'     => 'Conta criada com sucesso!'

        );

      } else {

        $var = array(

          'status'  => false,

          'msg'     => 'Falha, verifique os dados ou se a conta já existe.'

        );

      }

    } else {

      $var = array(

        'status'  => false,

        'msg'     => 'Todos os campos são obrigatórios.'

      );

    }

  }

  if ($_POST['cod'] == 13) {

    if (!empty($_POST['nome']) && !empty($_POST['email']) && !empty($_POST['tipo']) && !empty($_POST['id_esc'])) {

      if (empty($_POST['loja'])) {
        $_POST['loja'] = '0';
      }

      if (!empty($_POST['senha'])) {
        try{
          $update_sql = "UPDATE user SET 
            nome = '".$_POST['nome']."',
            email = '".$_POST['email']."',
            senha = '".md5($_POST['senha'])."',
            senha_block = '".$_POST['senha_block']."',
            loja_id = '".$_POST['loja']."',
            tipo_user = '".$_POST['tipo']."'";

          if(isset($_POST['email_vendedor']) && !empty($_POST['email_vendedor'])){
            $update_sql .= ", email_vendedor = '".$_POST['email_vendedor']."'";
          }
          if(isset($_POST['user_geral']) && !empty($_POST['user_geral'])){
            $update_sql .= ", user_geral = '".$_POST['user_geral']."'";
          }
          $update_sql .= " WHERE id = '".$_POST['id_esc']."'";
          
          $getUserExist = mysqli_query($conn, "SELECT id FROM user WHERE senha = '". md5($_POST['senha']) ."'");
          if (mysqli_num_rows($getUserExist) == 0) {
            $update = mysqli_query($conn, $update_sql);

            if ($update){
              $var = array(
                'status'  => true,
                'msg'     => 'Dados atualizados com sucesso!'
              );
            } else {
              $var = array(
                'status'  => false,
                'msg'     => 'Não foi possível atualizar os dados.'
              );
            }
          } else {
            $var = array(
              'status'  => false,
              'msg'     => 'Senha já cadastrada.'
            );
          }
        } catch (Exception $e){
          $var = array(
            'status'  => true,
            'msg'     => $e->getMessage()
          );
        }
      } else {
        $update_sql = "UPDATE user SET 
        nome = '".$_POST['nome']."',
        email = '".$_POST['email']."',
        senha_block = '".$_POST['senha_block']."',
        loja_id = '".$_POST['loja']."',
        tipo_user = '".$_POST['tipo']."'";

        if(isset($_POST['email_vendedor']) && !empty($_POST['email_vendedor'])){
          $update_sql .= ", email_vendedor = '".$_POST['email_vendedor']."'";
        }
        if(isset($_POST['user_geral']) && !empty($_POST['user_geral'])){
          $update_sql .= ", user_geral = '".$_POST['user_geral']."'";
        }
        $update_sql .= " WHERE id = '".$_POST['id_esc']."'";

        // echo $update_sql;

        $update = mysqli_query($conn, $update_sql);

        if ($update){
          $var = array(
            'status'  => true,
            'msg'     => 'Dados atualizados com sucesso!'
          );
        } else {
          $var = array(
            'status'  => false,
            'msg'     => 'Não foi possível atualizar os dados.'
          );
        }
      }
    } else {
      $var = array(
        'status'  => false,
        'msg'     => 'Todos os campos são obrigatórios.'
      );
    }
  }

  if ($_POST['cod'] == 14) {
    if (!empty($_POST['id'])) {
      $id_user = $_POST['id'];
      $array_geral = array();
      $cc1 = 0;

      $getCategoriaPrivilegio = mysqli_query($conn, "SELECT * FROM categoria_privilegio ORDER BY descricao ASC");
      if (mysqli_num_rows($getCategoriaPrivilegio) > 0) {
        while ($listarCategorias = mysqli_fetch_array($getCategoriaPrivilegio)) {
          $cc2 = 0;
          $array_privilegios = array();
          $getPrivilegio = mysqli_query($conn, "SELECT * FROM privilegios WHERE categoria_privilegio_id = '".$listarCategorias['id']."' ORDER BY descricao ASC");
          while ($listarPrivilegios = mysqli_fetch_array($getPrivilegio)) {
            $getPrivilegioAuser = mysqli_query($conn, "SELECT * FROM controle_privilegios WHERE id_user = '$id_user' AND id_privilegio = '".$listarPrivilegios['id']."'");
            $active = false;
            if (mysqli_num_rows($getPrivilegioAuser) > 0) {$active = true;}
            $array_privilegios[$cc2] = array(
              'descricao' => $listarPrivilegios['descricao'],
              'id'    => $listarPrivilegios['id'],
              'active'  => $active
            );
          $cc2++;}

          $array_geral[$cc1] = array(
            'categoria' => $listarCategorias['descricao'],
            'camada1' => $array_privilegios
          );
        $cc1++;}
        $var = $array_geral;
      } else { $var = false; }
    } else { $var = false; }
  }

  if ($_POST['cod'] == 15) {
    if (!empty($_POST['id_user_esc'])) {
      $user = $_POST['id_user_esc'];
      //deletar todos os privilégios deste usuários
      $delete_privilegios = mysqli_query($conn, "DELETE FROM controle_privilegios WHERE id_user = '$user'");
      if ($delete_privilegios) {
        //agora vou reatribuir os previlégios que foram selecionados
        if (!empty($_POST['check'])) {
          $contador = count($_POST['check']);
          for ($cc=0;$cc<$contador;$cc++) {
            $add_privilegios = mysqli_query($conn, "INSERT INTO controle_privilegios(id_user,id_privilegio,id_user_create) 
              VALUES('$user','".$_POST['check'][$cc]."','".$_SESSION['id_user']."')");
          }
        }
        $var = array(
          'status'  => true,
          'msg'     => 'Sucesso.'
        );
      } else {
        $var = array(
          'status'  => false,
          'msg'     => 'Falha.'
        );
      }
    } else {
      $var = array(
        'status'  => false,
        'msg'     => 'Falha.'
      );
    }
  }

  if ($_POST['cod'] == 16) {
    if (!empty($_POST['id_solicitacao'])) {
      $getProdutos = mysqli_query($conn, "SELECT * FROM processos_produtos WHERE id_processo = '". $_POST['id_solicitacao'] ."'");
      $contador = mysqli_num_rows($getProdutos);
      $array = array();
      if ($contador > 0) {
        for ($cc=0;$cc<$contador;$cc++) {
          $lista = mysqli_fetch_array($getProdutos);

          $getDadosProdutos = mysqli_fetch_array(mysqli_query($conn_s, "SELECT * FROM uni_produtos_web WHERE id = '". $lista['id_produto'] ."'"));

          $array[$cc] = array(
            "id" => $getDadosProdutos['id'],
            "descricao" => trim($getDadosProdutos['SQL_IDESCRI']),
            "quantidade" => $lista['qtd_produto'],
            "deposito" => $getDadosProdutos['SQL_ILOCDEP'],
            "codigo" => trim($getDadosProdutos['SQL_ICODBUS'])
          );
        }
        $var = $array;
      } else {
        $var = false;
      }
    } else {
      $var = false;
    }
  } 

  if ($_POST['cod'] == 17) {
    if (!empty($_POST['id_solicitacao']) && !empty($_POST['senha'])) {
      $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));
      if (!empty($getDadosuser)) {
        if ($getDadosuser['senha_block'] == 1) {
          $alguma_alteracao = 0;
          $qtd_zerados = 0;
          $array_itens_em_falta = "";
          for ($cc=0;$cc<count($_POST['id_produto']);$cc++) {

            $getProduto = mysqli_query($conn, "SELECT * FROM processos_produtos 
              WHERE id_processo = '". $_POST['id_solicitacao'] ."' AND id_produto = '". $_POST['id_produto'][$cc] ."'");
            $listaProduto = mysqli_fetch_array($getProduto);

            if ($listaProduto['qtd_produto'] != $_POST['qtd'][$cc]) {
              $alguma_alteracao++;
              $up = mysqli_query($conn, "UPDATE processos_produtos SET qtd_retirada = '".$_POST['qtd'][$cc]."' 
                WHERE id = '".$listaProduto['id']."'");

              //se algum item não foi encontrado devo adicionar ao array para mostrar via email ao adm
              $tot_n_encontrado = $listaProduto['qtd_produto'] - $_POST['qtd'][$cc];
              $selectDataProd = mysqli_fetch_array(mysqli_query($conn_s, "SELECT SQL_ICODBUS,SQL_IDESCRI FROM uni_produtos_web WHERE id = '".$listaProduto['id_produto']."'"));
              
              $array_itens_em_falta .= "<p><b>Produto:</b> ".$selectDataProd['SQL_ICODBUS']." - ".$selectDataProd['SQL_IDESCRI']."<br><b>Qtd Solicitada:</b> ".$listaProduto['qtd_produto']." <br><b>Qtd não encontrada:</b> $tot_n_encontrado</p>";
            }

            if ($_POST['qtd'][$cc] == 0) {
              $qtd_zerados++;
            }

          }

          if ($alguma_alteracao > 0) {
            //houve mudanças 
            if ($qtd_zerados == count($_POST['id_produto'])) {
              //se cair aqui é por que todos os itens estão zerados
              $add_obs = mysqli_query($conn, "INSERT INTO processos_obs(id_user,id_processo,obs_descricao) 
                VALUES('".$getDadosuser['id']."','".trim($_POST['id_solicitacao'])."','".$_POST['obs_prod']."')");
              $var = array(
                'status'  => true,
                'msg'     => 'Processo concluído com sucesso!'
              );
            } else {
              $add_obs = mysqli_query($conn, "INSERT INTO processos_obs(id_user,id_processo,obs_descricao) 
                VALUES('".$getDadosuser['id']."','".trim($_POST['id_solicitacao'])."','".$_POST['obs_prod']."')");
              //se cair aqui é por que houve modificações mas nem todos os itens estão zerados
              $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado,id_user,id_processo)VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','2')");
              
              if ($addLine) {
                $var = array(
                  'status'  => true,
                  'msg'     => 'Processo concluído com sucesso!1'
                );
              } else {
                $var = array(
                  'status'  => false,
                  'msg'     => 'Não foi possível concluir o processo, tente novamente.'
                );
              }
            }

            $array_itens_em_falta .= "<p><b>OBSERVAÇÃO: </b>".$_POST['obs_prod']."</p>";

            //Enviar por email a lista de produtos não encontrados
              $mail = new PHPMailer(true);
              // $mail->SMTPDebug = SMTP::DEBUG_SERVER;
              $mail->isSMTP();
              $mail->CharSet    = 'UTF-8';
              $mail->Host       = 'smtp.gmail.com';
              $mail->SMTPAuth   = true;
              $mail->Username   = 'unidossolicitacoes@gmail.com';
              $mail->Password   = 'xtdc1227';
              $mail->SMTPSecure = 'tls';
              $mail->Port       = 587;

              $mail->setFrom('unidossolicitacoes@gmail.com', 'Unidos Importados');
              $mail->addAddress('conferencia.sup@unidosimportados.com.br', 'Unidos Importados');
              $mail->addAddress('suporte@unidosimportados.com.br', 'Unidos Importados');

              $mail->isHTML(true);
              $mail->Subject = 'Produtos em Falta - Solicitação: '.$_POST['id_solicitacao'];
              $mail->Body    = $array_itens_em_falta;
              $mail->AltBody = $array_itens_em_falta;
            //Enviar por email a lista de produtos não encontrados
            $variavel = $mail->send();

          } else {
            //não houve mudanças
            $addLine = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado ,id_user,id_processo) VALUES('".trim($_POST['id_solicitacao'])."','".$getDadosuser['id']."','1')");
            
            if ($addLine) {
              $var = array(
                'status'  => true,
                'msg'     => 'Processo concluído com sucesso!2'
              );
            } else {
              $var = array(
                'status'  => false,
                'msg'     => 'Não foi possível concluir o processo, tente novamente.'
              );
            }
          }
        
        }
      }
    } else {
      $var = array(
        'status'  => false,
        'msg'     => 'Todos os campos são obrigatórios.'
      );
    }
  }

  if ($_POST['cod'] == 18) {
    if (!empty($_POST['id_solicitacao'])) {
      $getProdutos = mysqli_query($conn, "SELECT * FROM processos_produtos WHERE id_processo = '".$_POST['id_solicitacao']."'");
      $contador = mysqli_num_rows($getProdutos);
      $array = [];
      for ($cc=0;$cc<$contador;$cc++) {
        $lista = mysqli_fetch_array($getProdutos);
        //pegar informações do produto
        $getInfo = mysqli_fetch_array(mysqli_query($conn_s, "SELECT * FROM uni_produtos_web WHERE id = '".$lista['id_produto']."'"));
        //adicionar a quantidade real que foi retirada do deposito
        $quantidade_real = $lista['qtd_retirada'] > 0 ? $lista['qtd_retirada'] : $lista['qtd_produto'];

        $cod = !empty(trim($getInfo['SQL_ICODBUS'])) ? trim($getInfo['SQL_ICODBUS']): "";
        $descricao = !empty($cod) ? $cod." - ".trim($getInfo['SQL_IDESCRI']) : trim($getInfo['SQL_IDESCRI']);

        $array[$cc] = array(
          'id'          => $lista['id_produto'],
          'descricao'   => $descricao,
          'quantidade'  => $quantidade_real,
        );
      }
      $var = $array;
    } else { $var = false; }
  }

  if ($_POST['cod'] == 19) {
    $contador = count($_POST['id_produto']);
    $itens_venda  = [];
    $itens_guarda = [];
    for ($cc=0;$cc<$contador;$cc++) {

      if ($_POST['qtd_venda'][$cc] > 0) {
        array_push($itens_venda, array(
          'id' => $_POST['id_produto'][$cc],
          'qtd' => $_POST['qtd_venda'][$cc]
        ));
      }

      if ($_POST['qtd_guarda'][$cc] > 0) {
        array_push($itens_guarda, array(
          'id' => $_POST['id_produto'][$cc],
          'qtd' => $_POST['qtd_guarda'][$cc]
        ));
      } 
      
    }

    //Adicionar novo processo para venda
    if (!empty($itens_venda)) {
      $addSolicitacao = mysqli_query($conn, "INSERT INTO processos_iniciados(id_user,surgimento,id_surgimento, loja_id) VALUES('".$_SESSION['id_user']."','1','".$_POST['id_solicitacao']."', $loja_id)");
      if ($addSolicitacao) {
        $idSolicitacao = mysqli_fetch_array(mysqli_query($conn, "SELECT MAX(id) as id FROM processos_iniciados 
          WHERE id_user = '".$_SESSION['id_user']."'"));

        //salvar os produtos na tabela
        for ($cc=0;$cc<count($itens_venda);$cc++) {
          $setProduto = mysqli_query($conn, "INSERT processos_produtos(id_produto,qtd_produto,id_processo) 
            VALUES('".$itens_venda[$cc]['id']."','".$itens_venda[$cc]['qtd']."','$idSolicitacao[0]')");
        }

        $addGerenciamento = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado,id_user,id_processo) 
          VALUES('$idSolicitacao[0]','".$_SESSION['id_user']."','1'),
          ('$idSolicitacao[0]','".$_SESSION['id_user']."','2'),
          ('$idSolicitacao[0]','".$_SESSION['id_user']."','3'),
          ('$idSolicitacao[0]','".$_SESSION['id_user']."','4'),
          ('$idSolicitacao[0]','".$_SESSION['id_user']."','5')");
      }
    }

    //Adicionar novo processo para guardar
    if (!empty($itens_guarda)) {
      $addSolicitacao2 = mysqli_query($conn, "INSERT INTO processos_iniciados(id_user,surgimento,id_surgimento, loja_id) VALUES('".$_SESSION['id_user']."','1','".$_POST['id_solicitacao']."', $loja_id)");
      if ($addSolicitacao2) {
        $idSolicitacao2 = mysqli_fetch_array(mysqli_query($conn, "SELECT MAX(id) as id FROM processos_iniciados 
          WHERE id_user = '".$_SESSION['id_user']."'"));

        //salvar os produtos na tabela
        for ($cc=0;$cc<count($itens_guarda);$cc++) {
          $setProduto = mysqli_query($conn, "INSERT processos_produtos(id_produto,qtd_produto,id_processo) 
            VALUES('".$itens_guarda[$cc]['id']."','".$itens_guarda[$cc]['qtd']."','$idSolicitacao2[0]')");
        }

        $addGerenciamento = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado,id_user,id_processo) 
          VALUES('$idSolicitacao2[0]','".$_SESSION['id_user']."','1'),
          ('$idSolicitacao2[0]','".$_SESSION['id_user']."','2'),
          ('$idSolicitacao2[0]','".$_SESSION['id_user']."','3'),
          ('$idSolicitacao2[0]','".$_SESSION['id_user']."','4'),
          ('$idSolicitacao2[0]','".$_SESSION['id_user']."','6')");
      }
    }

    //atualizar o processo atual para que seja aposentado
    $add1 = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado,id_user,id_processo) 
          VALUES('".$_POST['id_solicitacao']."','".$_SESSION['id_user']."','10')");
    $obs = "Lançamento Aposentado";
    $add2 = mysqli_query($conn, "INSERT INTO processos_obs(id_processo,id_user,obs_descricao) 
          VALUES('".$_POST['id_solicitacao']."','".$_SESSION['id_user']."','$obs')");
    $cancelar = mysqli_query($conn, "UPDATE processos_iniciados SET situacao = '1', aposentadoria = '1' WHERE id = '".$_POST['id_solicitacao']."'");

    $var = true;
  }

  if ($_POST['cod'] == 20) {
    if (!empty($_POST['senha'])) {

      $getDadosuser = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM user WHERE senha = '".trim(md5($_POST['senha']))."'"));
      if (!empty($getDadosuser)) {

        $contador = count($_POST['id_produto']);
        $itens_amostra  = [];
        $itens_guarda = [];
        for ($cc=0;$cc<$contador;$cc++) {

          if ($_POST['qtd_venda'][$cc] > 0) {
            array_push($itens_amostra, array(
              'id' => $_POST['id_produto'][$cc],
              'qtd' => $_POST['qtd_venda'][$cc]
            ));
          }

          if ($_POST['qtd_guarda'][$cc] > 0) {
            array_push($itens_guarda, array(
              'id' => $_POST['id_produto'][$cc],
              'qtd' => $_POST['qtd_guarda'][$cc]
            ));
          } 
          
        }

        $getInfoProcessoIniciado = mysqli_fetch_array(mysqli_query($conn, "SELECT * FROM processos_iniciados WHERE id = '".$_POST['id_solicitacao']."'"));

        //pegar passo 01
        $getGerenciamento01 = mysqli_fetch_array(mysqli_query($conn, "SELECT id_user FROM processos_gerenciamento 
          WHERE id_processo_iniciado = '".$_POST['id_solicitacao']."' AND id_processo = '1'"));
        //pegar passo 02
        $getGerenciamento02 = mysqli_fetch_array(mysqli_query($conn, "SELECT id_user FROM processos_gerenciamento 
          WHERE id_processo_iniciado = '".$_POST['id_solicitacao']."' AND id_processo = '2'"));
        //pegar passo 03
        $getGerenciamento03 = mysqli_fetch_array(mysqli_query($conn, "SELECT id_user FROM processos_gerenciamento 
          WHERE id_processo_iniciado = '".$_POST['id_solicitacao']."' AND id_processo = '3'"));
        //pegar passo 04
        $getGerenciamento04 = mysqli_fetch_array(mysqli_query($conn, "SELECT id_user FROM processos_gerenciamento 
          WHERE id_processo_iniciado = '".$_POST['id_solicitacao']."' AND id_processo = '4'"));

        //Adicionar novo processo para amostra
        if (!empty($itens_amostra)) {
          $addSolicitacao = mysqli_query($conn, "INSERT INTO processos_iniciados(id_user,surgimento,id_surgimento, loja_id) VALUES('".$getInfoProcessoIniciado['id_user']."',
            '1','".$_POST['id_solicitacao']."', $loja_id)");
          if ($addSolicitacao) {
            $idSolicitacao = mysqli_fetch_array(mysqli_query($conn, "SELECT MAX(id) as id FROM processos_iniciados 
              WHERE id_user = '".$getInfoProcessoIniciado['id_user']."'"));

            //salvar os produtos na tabela
            for ($cc=0;$cc<count($itens_amostra);$cc++) {
              $setProduto = mysqli_query($conn, "INSERT processos_produtos(id_produto,qtd_produto,id_processo) 
                VALUES('".$itens_amostra[$cc]['id']."','".$itens_amostra[$cc]['qtd']."','$idSolicitacao[0]')");
            }

            $addGerenciamento = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado,id_user,id_processo) 
              VALUES('$idSolicitacao[0]','".$getGerenciamento01['id_user']."','1'),
              ('$idSolicitacao[0]','".$getGerenciamento02['id_user']."','2'),
              ('$idSolicitacao[0]','".$getGerenciamento03['id_user']."','3'),
              ('$idSolicitacao[0]','".$getGerenciamento04['id_user']."','4')");
          }
        }

        //Adicionar novo processo para guardar
        if (!empty($itens_guarda)) {
          $addSolicitacao2 = mysqli_query($conn, "INSERT INTO processos_iniciados(id_user,surgimento,id_surgimento, loja_id) VALUES('".$getInfoProcessoIniciado['id_user']."','1',
            '".$_POST['id_solicitacao']."', $loja_id)");
          if ($addSolicitacao2) {
            $idSolicitacao2 = mysqli_fetch_array(mysqli_query($conn, "SELECT MAX(id) as id FROM processos_iniciados 
              WHERE id_user = '".$getInfoProcessoIniciado['id_user']."'"));

            //salvar os produtos na tabela
            for ($cc=0;$cc<count($itens_guarda);$cc++) {
              $setProduto = mysqli_query($conn, "INSERT processos_produtos(id_produto,qtd_produto,id_processo) 
                VALUES('".$itens_guarda[$cc]['id']."','".$itens_guarda[$cc]['qtd']."','$idSolicitacao2[0]')");
            }

            $addGerenciamento = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado,id_user,id_processo) 
              VALUES('$idSolicitacao2[0]','".$getGerenciamento01['id_user']."','1'),
              ('$idSolicitacao2[0]','".$getGerenciamento02['id_user']."','2'),
              ('$idSolicitacao2[0]','".$getGerenciamento03['id_user']."','3'),
              ('$idSolicitacao2[0]','".$getGerenciamento04['id_user']."','4'),
              ('$idSolicitacao2[0]','".$getDadosuser['id']."','6')");
          }
        }

        //atualizar o processo atual para que seja aposentado
        $add1 = mysqli_query($conn, "INSERT INTO processos_gerenciamento(id_processo_iniciado,id_user,id_processo) 
              VALUES('".$_POST['id_solicitacao']."','".$getDadosuser['id']."','10')");
        $obs = "Lançamento Aposentado - Amostra e Guardar";
        $add2 = mysqli_query($conn, "INSERT INTO processos_obs(id_processo,id_user,obs_descricao) 
              VALUES('".$_POST['id_solicitacao']."','".$getDadosuser['id']."','$obs')");
        $cancelar = mysqli_query($conn, "UPDATE processos_iniciados SET situacao = '1', aposentadoria = '1' WHERE id = '".$_POST['id_solicitacao']."'");

        $var = true;

      } else {
        $var = false;
      }
    } else {
      $var = false;
    }
  }

} else {
  //caso o código não exista essa será a mensagem de resposta
  $var = array(
    'status'  => false,
    'msg'     => 'Não foi possível completar o processo, tente novamente mais tarde!'
  );
}

echo json_encode($var); 